-- =================================================================== --
-- Sistema   : Atendimento a Clientes                                  --
-- Data      : ??/??/????                                              --
-- Criao   : Zed                                                     --
-- Obsjetivo : Gerar o relatrio de Faturamento por Vo/Perodo        --
-- MANUTENO: 11/07/2001 - LUCIANA CORREA - MULTI-EMPRESA
-- =================================================================== --
-- @C:\WIN_PRJ\SQL\ORACLE\2750_ATESTP_GERA_REL_VOOPER.SQL
-- EXEC GERA_REL_VOOPER('VP','03/01/2000','17/01/2000','_030_041_111_114_1191_121_125_127_143_156_16_160_161_164_166_194_195_200_201_2060_2080_2081_2082_2082A_2090_2091_21_220_234_235_238_239_239A_243_246_262_290_294_356_358_472_476_4770_4773_4784_480_483_483A_4840_486_487_488_4888_489_490_492_4950_496_530_532_535_536_538_540_542_546_554_555_5563_562_575_580_582_583_584_585_586_588_589_590_592_594_595_596_598_6051_6153_6234_6242_6247_6253_6281_6285_6382_6384_6456_6561_6602_6911_6914_6917_6918_6919_6957_730_731_732_734_737_770_772_780_781_782_784_786_787_788_790_791_792_794_840_841_888_901_950_953_956_957_959_','_0001_0002_0003_0004_0005_0006_0007_0032_0034_0036_0039_0041_6110_','28/01/2000 15:21:00');
-- ================================================================== --

create or replace 
PROCEDURE GERA_REL_VOOPER (
   P_CDFILIAL     IN VARCHAR2,
   P_SGCIA        IN COMPANHIA.SGCIA%TYPE,
   P_DATAINI      IN DATE,
   P_DATAFIM      IN DATE,
   P_VOOS         IN VARCHAR2,
   P_CLASSES      IN VARCHAR2,
   P_DTHRVOOPER   IN VARCHAR2,
   P_IDTIPOREL    IN VARCHAR2) AS

   V_DIA          VARCHAR2(02);
   V_UPDATE_TEXT  VARCHAR2(1000);
   C_UPDATE       INTEGER;
   V_RESULT       INTEGER;

BEGIN
   IF (P_IDTIPOREL = 1) THEN
      INSERT INTO RELAT_VOOPER
        (CDFILIAL,DTHRVOOPER,CDCIAVPER,NRVOOVPER,CDTRECHOVPER,CDCLASVPER,
         CDSERVVPER,QTTTSERVPER,QTTTSBYVPER,QTTTSBYNVPER,VRUNREAVPER,
         VRURSBYVPER,VRURSBYNVPER,VRUNDOLVPER,VRUDSBYVPER,VRUDSBYNVPER,
         VRTTREAVPER,VRTTRSBYVPER,VRTTRSBYNVPER,VRTTDOLVPER,
         VRTTDSBYVPER,VRTTDSBYNVPER)
      (SELECT SP.CDFILIAL,
              TO_DATE(P_DTHRVOOPER,'DD/MM/YYYY HH24:MI:SS'),
              SP.CDCIA,SP.NRVOO,SP.CDTRECHO,SP.CDAGRDEDE,SP.CDSERVICO,
              SUM(SP.QTATUAPRODSP),SUM(SP.QTSESBYUTSP),
              SUM(SP.QTSESBYPRSP-SP.QTSESBYUTSP),
              SP.VRPRURESESP,(SP.VRPRUSBYSP*CF.VRPERSBYUT/100),
              (SP.VRPRUSBYSP*CF.VRPERSBYNUT/100),SP.VRPRUDOLSESP,
              (SP.VRPRUSBYSP*CF.VRPERSBYUT/100),
              (SP.VRPRUSBYSP*CF.VRPERSBYNUT/100),
              SUM(SP.QTSERFATSP * SP.VRPRURESESP),
              SUM((SP.QTSESBYUTSP*(SP.VRPRUSBYSP*CF.VRPERSBYUT/100))),
              SUM((SP.QTSESBYPRSP-SP.QTSESBYUTSP)*(SP.VRPRUSBYSP*CF.VRPERSBYNUT/100)),
              SUM((SP.QTSERFATSP*SP.VRPRUDOLSESP)),
              SUM((SP.QTSESBYUTSP*(SP.VRPRUSBYSP*CF.VRPERSBYUT/100))),
              SUM(((SP.QTSESBYPRSP-SP.QTSESBYUTSP)*(SP.VRPRUSBYSP*CF.VRPERSBYNUT/100)))
       FROM SERVPLANO SP, DELIVERY DV, COMPANHIA CI, CIAFILI CF
       WHERE (SP.IDSITSERSP = '2')                          AND
             ((P_VOOS = 'T')                                OR
              (INSTR(P_VOOS,'_'||SP.NRVOO||SP.CDTRECHO||'_') > 0))    AND
             ((P_CLASSES = 'T')                             OR
              (INSTR(P_CLASSES, SP.CDAGRDEDE) > 0))         AND
             (DV.DTEMISDEL BETWEEN P_DATAINI AND P_DATAFIM) AND
             (DV.IDSITDEL  <> '3'          )                AND
             (CI.SGCIA      = P_SGCIA      )                AND
             (SP.CDCIA      = CI.CDCIA     )                AND
             (SP.NRDELIVERY = DV.NRDELIVERY)                AND
             (SP.CDFILIAL   = P_CDFILIAL)                   AND
             (DV.CDFILIAL   = P_CDFILIAL)                   AND
             (CI.CDCIA      = CF.CDCIA)                     AND
             (CF.CDFILIAL   = P_CDFILIAL)
       GROUP BY SP.CDFILIAL,SP.CDCIA,SP.NRVOO,SP.CDTRECHO,SP.CDAGRDEDE,SP.CDSERVICO,
                SP.VRPRURESESP,(SP.VRPRUSBYSP*CF.VRPERSBYUT/100),
                (SP.VRPRUSBYSP*CF.VRPERSBYNUT/100),
                SP.VRPRUDOLSESP);
   ELSE
      INSERT INTO RELAT_VOOPER
        (CDFILIAL,DTHRVOOPER,CDCIAVPER,NRVOOVPER,CDTRECHOVPER,CDCLASVPER,
         CDSERVVPER,QTTTSERVPER,QTTTSBYVPER,QTTTSBYNVPER,VRUNREAVPER,
         VRURSBYVPER,VRURSBYNVPER,VRUNDOLVPER,VRUDSBYVPER,VRUDSBYNVPER,
         VRTTREAVPER,VRTTRSBYVPER,VRTTRSBYNVPER,VRTTDOLVPER,
         VRTTDSBYVPER,VRTTDSBYNVPER)
      (SELECT SP.CDFILIAL,
              TO_DATE(P_DTHRVOOPER,'DD/MM/YYYY HH24:MI:SS'),SP.CDCIA,
              'XXXXX','XXXX',SP.CDAGRDEDE,SP.CDSERVICO,
              SUM(SP.QTATUAPRODSP),SUM(SP.QTSESBYUTSP),
              SUM(SP.QTSESBYPRSP-SP.QTSESBYUTSP),SP.VRPRURESESP,
              (SP.VRPRUSBYSP*CF.VRPERSBYUT/100),
              (SP.VRPRUSBYSP*CF.VRPERSBYNUT/100),SP.VRPRUDOLSESP,
              (SP.VRPRUSBYSP*CF.VRPERSBYUT/100),
              (SP.VRPRUSBYSP*CF.VRPERSBYNUT/100),
              SUM((SP.QTSERFATSP)* (SP.VRPRURESESP)),
              SUM((SP.QTSESBYUTSP*(SP.VRPRUSBYSP*CF.VRPERSBYUT/100))),
              SUM(((SP.QTSESBYPRSP-SP.QTSESBYUTSP)*(SP.VRPRUSBYSP*CF.VRPERSBYNUT/100))),
              SUM((SP.QTSERFATSP*SP.VRPRUDOLSESP)),
              SUM((SP.QTSESBYUTSP*(SP.VRPRUSBYSP*CF.VRPERSBYUT/100))),
              SUM(((SP.QTSESBYPRSP-SP.QTSESBYUTSP)*(SP.VRPRUSBYSP*CF.VRPERSBYNUT/100)))
       FROM SERVPLANO SP, DELIVERY DV, COMPANHIA CI, CIAFILI CF
       WHERE (SP.IDSITSERSP = '2')                          AND
             ((P_VOOS = 'T')                                OR
              (INSTR(P_VOOS,'_'||SP.NRVOO||SP.CDTRECHO||'_') > 0))    AND
             ((P_CLASSES = 'T')                             OR
              (INSTR(P_CLASSES, SP.CDAGRDEDE)>0))           AND
             (DV.DTEMISDEL BETWEEN P_DATAINI AND P_DATAFIM) AND
             (DV.IDSITDEL  <> '3'          )                AND
             (CI.SGCIA      = P_SGCIA      )                AND
             (SP.CDCIA      = CI.CDCIA     )                AND
             (SP.NRDELIVERY = DV.NRDELIVERY)                AND
             (SP.CDFILIAL   = P_CDFILIAL)                   AND
             (DV.CDFILIAL   = P_CDFILIAL)                   AND
             (CI.CDCIA      = CF.CDCIA)                     AND
             (CF.CDFILIAL   = P_CDFILIAL)
       GROUP BY SP.CDFILIAL,SP.CDCIA,SP.CDAGRDEDE,SP.CDSERVICO,SP.VRPRURESESP,
                (SP.VRPRUSBYSP * CF.VRPERSBYUT / 100),
                (SP.VRPRUSBYSP * CF.VRPERSBYNUT / 100),
                SP.VRPRUDOLSESP);
   END IF;

   FOR CURS IN (SELECT *
                FROM RELAT_VOOPER
                WHERE
                  (CDFILIAL   = P_CDFILIAL) AND
                  (DTHRVOOPER = TO_DATE(P_DTHRVOOPER,'DD/MM/YYYY HH24:MI:SS'))) LOOP

      FOR CURS2 IN (SELECT DE.DTEMISDEL,SUM(SP.QTATUAPRODSP) AS QTSER,
                           SUM(SP.QTSESBYUTSP) AS QTSBY,
                           SUM(SP.QTSESBYPRSP-SP.QTSESBYUTSP) AS QTSBYN
                    FROM SERVPLANO SP, DELIVERY DE, COMPANHIA CO, CIAFILI CF
                    WHERE (SP.IDSITSERSP = '2'           )                AND
                          (SP.CDCIA      = CURS.CDCIAVPER)                AND
                          (((SP.NRVOO = CURS.NRVOOVPER)                   AND
                            (SP.CDTRECHO = CURS.CDTRECHOVPER))            OR
                           ((P_IDTIPOREL = 2)                             AND
                            ((P_VOOS = 'T')                               OR
                             (INSTR(P_VOOS,'_'||SP.NRVOO||SP.CDTRECHO||'_') > 0)))) AND
                          (SP.CDAGRDEDE    = CURS.CDCLASVPER )            AND
                          (SP.CDSERVICO    = CURS.CDSERVVPER )            AND
                          (SP.VRPRURESESP  = CURS.VRUNREAVPER)            AND
                          (SP.VRPRUDOLSESP = CURS.VRUNDOLVPER)            AND
                          (SP.NRDELIVERY   = DE.NRDELIVERY)               AND
                          (DE.IDSITDEL   <> '3'         )                 AND
                          (DE.DTEMISDEL BETWEEN P_DATAINI AND P_DATAFIM)  AND
                          (SP.CDCIA  = CO.CDCIA)                          AND
                          ((SP.VRPRUSBYSP * CF.VRPERSBYUT  / 100) = CURS.VRURSBYVPER ) AND
                          ((SP.VRPRUSBYSP * CF.VRPERSBYNUT / 100) = CURS.VRURSBYNVPER) AND
                          (SP.CDFILIAL = P_CDFILIAL)                                          AND
                          (DE.CDFILIAL = P_CDFILIAL)                                          AND
                          (CO.CDCIA    = CF.CDCIA)                                            AND
                          (CF.CDFILIAL = P_CDFILIAL)
                    GROUP BY DE.DTEMISDEL) LOOP

         V_DIA := LPAD(TO_CHAR((CURS2.DTEMISDEL - P_DATAINI) + 1),2,'0');

         V_UPDATE_TEXT := '';
         V_UPDATE_TEXT := V_UPDATE_TEXT ||'UPDATE RELAT_VOOPER ';
         V_UPDATE_TEXT := V_UPDATE_TEXT ||'SET QTSER'  || V_DIA || 'VPER = :X,';
         V_UPDATE_TEXT := V_UPDATE_TEXT ||'    QTSBY'  || V_DIA || 'VPER = :Y,';
         V_UPDATE_TEXT := V_UPDATE_TEXT ||'    QTSBYN' || V_DIA || 'VPER = :Z ';
         V_UPDATE_TEXT := V_UPDATE_TEXT ||'WHERE (DTHRVOOPER   = :A) AND';
         V_UPDATE_TEXT := V_UPDATE_TEXT ||'      (CDCIAVPER    = :B) AND';
         V_UPDATE_TEXT := V_UPDATE_TEXT ||'      (NRVOOVPER    = :C) AND';
         V_UPDATE_TEXT := V_UPDATE_TEXT ||'      (CDTRECHOVPER = :D) AND';
         V_UPDATE_TEXT := V_UPDATE_TEXT ||'      (CDCLASVPER   = :E) AND';
         V_UPDATE_TEXT := V_UPDATE_TEXT ||'      (CDSERVVPER   = :F) AND';
         V_UPDATE_TEXT := V_UPDATE_TEXT ||'      (VRUNREAVPER  = :G) AND';
         V_UPDATE_TEXT := V_UPDATE_TEXT ||'      (VRUNDOLVPER  = :H) AND';
         V_UPDATE_TEXT := V_UPDATE_TEXT ||'      (VRURSBYVPER  = :I) AND';
         V_UPDATE_TEXT := V_UPDATE_TEXT ||'      (VRURSBYNVPER = :J) AND';
         V_UPDATE_TEXT := V_UPDATE_TEXT ||'      (CDFILIAL     = :K)    ';

         C_UPDATE := DBMS_SQL.OPEN_CURSOR;
         DBMS_SQL.PARSE(C_UPDATE, V_UPDATE_TEXT, DBMS_SQL.V7);
         DBMS_SQL.BIND_VARIABLE(C_UPDATE, ':X', CURS2.QTSER);
         DBMS_SQL.BIND_VARIABLE(C_UPDATE, ':Y', CURS2.QTSBY);
         DBMS_SQL.BIND_VARIABLE(C_UPDATE, ':Z', CURS2.QTSBYN);
         DBMS_SQL.BIND_VARIABLE(C_UPDATE, ':A', TO_DATE(P_DTHRVOOPER,'DD/MM/YYYY HH24:MI:SS'));
         DBMS_SQL.BIND_VARIABLE(C_UPDATE, ':B', CURS.CDCIAVPER);
         DBMS_SQL.BIND_VARIABLE(C_UPDATE, ':C', CURS.NRVOOVPER);
         DBMS_SQL.BIND_VARIABLE(C_UPDATE, ':D', CURS.CDTRECHOVPER);
         DBMS_SQL.BIND_VARIABLE(C_UPDATE, ':E', CURS.CDCLASVPER);
         DBMS_SQL.BIND_VARIABLE(C_UPDATE, ':F', CURS.CDSERVVPER);
         DBMS_SQL.BIND_VARIABLE(C_UPDATE, ':G', CURS.VRUNREAVPER);
         DBMS_SQL.BIND_VARIABLE(C_UPDATE, ':H', CURS.VRUNDOLVPER);
         DBMS_SQL.BIND_VARIABLE(C_UPDATE, ':I', CURS.VRURSBYVPER);
         DBMS_SQL.BIND_VARIABLE(C_UPDATE, ':J', CURS.VRURSBYNVPER);
         DBMS_SQL.BIND_VARIABLE(C_UPDATE, ':K', P_CDFILIAL);
         V_RESULT := DBMS_SQL.EXECUTE(C_UPDATE);
         DBMS_SQL.CLOSE_CURSOR(C_UPDATE);
      END LOOP;
   END LOOP;
END;

/


-- VERSAO --
BEGIN ATUVEROBJ('GERA_REL_VOOPER','5.85.000'); END;
/

